# cesar et vigenere
# sv - v 3.14
# décembre 2019

def cesar(texte, decalage = 3, decode = False):
    chiffre = ''
    if decode:
        decalage = 26 - decalage
    for caractere in texte:
        indice = ord(caractere) - 65
        indice += decalage
        indice = indice%26
        chiffre += chr(indice + 65)
    return chiffre

def coder_cesar(texte, decalage):
    return cesar(texte, decalage)

def decoder_cesar(texte, decalage):
    return cesar(texte, decalage, True)

def vigenere(texte, cle, decode = False):
    chiffre = ''
    for i, c in enumerate(texte):
        decalage = ord(cle[i%len(cle)]) - 65
        if decode:
            chiffre += decoder_cesar(c, decalage)
        else:
            chiffre += coder_cesar(c, decalage)
    return chiffre

def coder_vigenere(texte, cle):
    return vigenere(texte, cle)
                   
def decoder_vigenere(texte, cle):
    return vigenere(texte, cle, True)
     
